#include <avr/io.h>
#include <stdio.h>
#include <util/delay.h>

/* Pinii folositi pentru motorul de sus (motorul 2) */
#define IN21 PD6
#define IN22 PD2
#define IN23 PB3
#define IN24 PB4

/* Pinii folositi pentru motorul de jos (motorul 1) */
#define IN11 PC0
#define IN12 PC1
#define IN13 PC2
#define IN14 PC3

#define WAIT_TIME_M 2

/* inititaza servo motorul */
void init_servo()
{
    DDRD |= (1 << PD5);
    TCCR1A |= 1<<WGM11 | 1<<COM1A1 | 1<<COM1A0;
    TCCR1B |= 1<<WGM13 | 1<<WGM12 | 1<<CS10;
    ICR1 = 4999;
} 

/* misca servo motorul inainte si inapoi */
void start_servo()
{
    OCR1A= 10;
    _delay_ms(2000);
    OCR1A= 25;
    _delay_ms(2000);
}

/* opreste motorul 1 - folosit pentru initializare */
void stop_motor1()
{
   PORTC &= ~(1 << IN11);
   PORTC &= ~(1 << IN12);
   PORTC &= ~(1 << IN13);
   PORTC &= ~(1 << IN14);
}

/* initiaza porturile motorului 1 */
void init_motor1()
{
   DDRC |= (1 << IN11);
   DDRC |= (1 << IN12);
   DDRC |= (1 << IN13);
   DDRC |= (1 << IN14);

   _delay_ms(700);

   stop_motor1();
}

/* face o miscare folosind pinul 1 */
void in0()
{
   PORTC |= (1 << IN11);
   _delay_ms(WAIT_TIME_M);
   PORTC &= ~(1 << IN11);
   _delay_ms(WAIT_TIME_M);
}

/* face o miscare folosind pinul 2 */
void in1()
{
   PORTC |= (1 << IN12);
   _delay_ms(WAIT_TIME_M);
   PORTC &= ~(1 << IN12);
   _delay_ms(WAIT_TIME_M);
}

/* face o miscare folosind pinul 3 */
void in2()
{
   PORTC |= (1 << IN13);
   _delay_ms(WAIT_TIME_M);
   PORTC &= ~(1 << IN13);
   _delay_ms(WAIT_TIME_M);
}

/* face o miscare folosind pinul 4 */
void in3()
{
   PORTC |= (1 << IN14);
   _delay_ms(WAIT_TIME_M);
   PORTC &= ~(1 << IN14);
   _delay_ms(WAIT_TIME_M);
}

/* face 4 miscari in sensul acelor de ceasornic */
void move_cw1()
{
    in3();
    in0();
    in2();
    in1();
}

/* face 4 miscari in sens invers acelor de ceasornic */
void move_ccw1()
{
    in1();
    in2();
    in0();
    in3();
}

int main(void)
{
    init_servo();
    start_servo();

    init_motor1();

    while (1)
    {
        move_ccw1();
    }
}
